package scheme.interp;

public class ExtendEnv extends Env {
    private String x;
    private SchemeValue v;
    private Env rest;

    public ExtendEnv (String x, SchemeValue v, Env rest) {
        this.x = x;
        this.v = v;
        this.rest = rest;
    }

    public SchemeValue find (String y) throws VisitE {
        if (x.equals(y)) return v;
        else return rest.find(y);
    }

    public void set (String y, SchemeValue vy) throws VisitE { 
        if (x.equals(y)) v=vy;
        else rest.set(y,vy);
    }
}

