package scheme.interp;

public class PairV extends SchemeValue {
    private SchemeValue left, right; 

    public PairV (SchemeValue left, SchemeValue right) { 
        this.left = left;
        this.right = right; 
    }

    public SchemeValue getCar () throws VisitE {
        return left;
    }

    public SchemeValue getCdr () throws VisitE {
        return right;
    }

    public void setCar (SchemeValue v) throws VisitE {
        left = v;
    }

    public void setCdr (SchemeValue v) throws VisitE {
        right = v;
    }

    public String toString () {
        return "(" + left + " . " + right + ")";
    }
}
