package scheme.absyn;

public class AppE extends Exp {
    private Exp fun;
    private ExpList args;

    public AppE (Exp fun, ExpList args) {
        this.fun = fun;
        this.args = args;
    }

    public Exp getFun () { return fun; }

    public ExpList getArgs () { return args; }

    public void accept (scheme.interp.ExpVisitor v) throws scheme.interp.VisitE {
        v.visitAppE(this);
    }
}
