package scheme.interp;

import scheme.util.*;

public abstract class Continuation extends SchemeValue {

    public abstract void invoke (SchemeValue v) throws VisitE;

    public void apply (List argVs, Eval_Exp eval_exp) throws VisitE {
        eval_exp.setCont(this); // abort current continuation
        this.invoke((SchemeValue)argVs.hd()); // and use this one
        throw new Error(); // can never get here
    }

}

