package scheme.interp;

import scheme.absyn.ConstantD;
import scheme.absyn.EmptyListD;

public class Eval_Datum implements DatumVisitor {
    private SchemeValue v;
    private Eval_Constant eval_const; 

    public Eval_Datum (Eval_Constant eval_const) {
        this.eval_const = eval_const;
    }

    public SchemeValue getValue() { return v; }

    public void visitConstantD (ConstantD d) throws VisitE {
        d.get().accept(eval_const);
        v = eval_const.getValue();
    }

    public void visitEmptyListD (EmptyListD d) throws VisitE {
        v = new EmptyV();
    }
}
