// $ANTLR 2.7.1: "scheme.g" -> "SchemeLexer.java"$

package scheme.parser;
import scheme.absyn.*;
import scheme.util.*;

public interface SchemeTokenTypes {
	int EOF = 1;
	int NULL_TREE_LOOKAHEAD = 3;
	int TRUE = 4;
	int FALSE = 5;
	int LEQ = 6;
	int QUOTECHAR = 7;
	int LPAREN = 8;
	int RPAREN = 9;
	int MINUS = 10;
	int DOT = 11;
	int TIMES = 12;
	int PLUS = 13;
	int LESS = 14;
	int EQ = 15;
	int ID = 16;
	int INT = 17;
	int WS = 18;
	int COMMENT = 19;
	int APP = 20;
	int PRIM = 21;
	int EMPTY_LIST = 22;
	int DECL = 23;
	int PARAMS = 24;
	int LITERAL_quote = 25;
	// "set!" = 26
	int LITERAL_if = 27;
	int LITERAL_begin = 28;
	int LITERAL_let = 29;
	int LITERAL_letrec = 30;
	int LITERAL_lambda = 31;
	// "add1" = 32
	// "boolean?" = 33
	int LITERAL_car = 34;
	int LITERAL_cdr = 35;
	int LITERAL_cons = 36;
	// "integer?" = 37
	int LITERAL_not = 38;
	// "null?" = 39
	// "pair?" = 40
	// "procedure?" = 41
	// "sub1" = 42
	int LITERAL_void = 43;
	// "zero?" = 44
	// "eq?" = 45
	// "set-car!" = 46
	// "set-cdr!" = 47
	// "call/cc" = 48
	// "call-with-current-continuation" = 49
}
